#ifndef XATTR_H_SOURCECODEID
#define XATTR_H_SOURCECODEID
static char xattr_h_sourceCodeID[]="$Id: @(#)88  1.4.1.4 src/pdwebrte/authn/modules/pdxauthn/pdxauthnutils/xattr.h, pdweb.authn, amwebrte611 07/07/20 14:22:01 @(#) $";
#endif

/*
 * xattr.h
 *
 * External attributes utility functions
 */

#ifndef XATTR_H
#define XATTR_H

#if defined(__cplusplus)
extern "C" {
#endif

typedef struct {
    char *name;
    char *value;
} xattr_list_item_t;

typedef struct {
    long               length;
    xattr_list_item_t  *items;
} xattr_list_t;

#include "pdxauthn_decl.h"

#if defined(XATTR_DEPRECATED)
/*
 * Allocates an xattr_list_t and returns it.  Returns NULL on allocation
 * failure.
 */
PDXUTILS_DECLSPEC
xattr_list_t*
PDXUTILS_CALLTYPE
xattr_malloc(int list_size);
#endif

#if defined(XATTR_DEPRECATED)
/*
 * Frees an xattr_list_t and any items in the list.
 */
PDXUTILS_DECLSPEC
void
PDXUTILS_CALLTYPE
xattr_free(xattr_list_t *list);
#endif

/*
 * Returns a pointer to the value of the specified name in the xattr.
 * Returns 0 on success, but this does not indicate that the value was
 * found.  It is required that *value be set to NULL before calling this
 * function so the caller can determined if the value was located or not.  This
 * function returns a non-zero value on failure, usually only due to passing in
 * NULL for the list argument.
 */
PDXUTILS_DECLSPEC
int
PDXUTILS_CALLTYPE
xattr_get(xattr_list_t *list, char *name, char **value);

/*
 * Sets the name/value pair in the xattr list.  Does not replace existing entries
 * with the same name, rather it adds an additional entry.  Name and value must
 * be heap allocated values (using functions such as malloc() or free()) as
 * responsibilty for free()ing these values is taken over by the xattr list.
 * The caller must not directly free() or use these pointers after making this
 * call.  Returns 0 on success.  A non-zero return value indicates failure,
 * usually due to lack of memory.  If the function indicates a failure then the
 * caller still owns the name and value items and must free them
 * as required.
 */
PDXUTILS_DECLSPEC
int 
PDXUTILS_CALLTYPE
xattr_set(xattr_list_t *list, char *name, char *value);

#if defined(XATTR_DEPRECATED)
/*
 * Duplicate the xnvlist.
 */
PDXUTILS_DECLSPEC
xattr_list_t *
PDXUTILS_CALLTYPE
xattr_dup(xattr_list_t *list);
#endif

#if defined(XATTR_DEPRECATED)
/*
 * Duplicate the items in the xattr.
 */
PDXUTILS_DECLSPEC
xattr_list_item_t *
PDXUTILS_CALLTYPE
xattr_items_dup(xattr_list_t *list);
#endif

#if defined(__cplusplus)
}
#endif

#endif /* end XATTR_H */
